﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Olap;
using System.Collections.ObjectModel;
using Infragistics.Olap.FlatData;
using System.ComponentModel.DataAnnotations;
using Infragistics.Olap.Data;
using Infragistics.Olap.Data.Base;
using Infragistics.Windows;


namespace PivotGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    

    public partial class MainWindow : Window
    {
       private ObservableCollection<CarsDataModified> _flatData;
        public ObservableCollection<CarsDataModified> FlatData
        {
            get
            {
                if (this._flatData == null)
                {
                    this._flatData = new ObservableCollection<CarsDataModified>();
                }

                return this._flatData;
            }
        }

        private void CreateFlatData()
        {
            this._flatData = new ObservableCollection<CarsDataModified>(CarsDataModified.GenerateDataCustom20());
        }

        public MainWindow()
        {
            InitializeComponent();

            IOlapViewModel temp = LayoutRoot.Resources["flatDataSource"] as IOlapViewModel;

            dataSelector.DataSource.PropertyChanged +=new System.ComponentModel.PropertyChangedEventHandler(DataSource_PropertyChanged);
        }

        void DataSource_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Metadata") 
            {
                HierarchicalItem rootItem = (sender as DataSourceBase).Metadata[0];
                List<HierarchicalItem> theChosenOnes = new List<HierarchicalItem>();

                foreach (HierarchicalItem item in rootItem.Items)
                {
                    if ((item.Caption=="Units sold")||(item.Caption=="Amount of sale"))
                    {
                        theChosenOnes.Add(item);
                    }
                }
                if (theChosenOnes.Count>0)
                {
                    foreach (var item in theChosenOnes)
                    {
                        rootItem.Items.Remove(item);
                    }
                }
            }
        }


        public abstract class Vehicle
        {
            public abstract string Model { get; set; }
            public abstract string Brand { get; set; }

            public abstract string VehicleKind();
            public abstract int VehicleTiresNumber();
        }

        public class Car : Vehicle
        {
            public override string Brand { get; set; }
            public override string Model { get; set; }
            public string Modification { get; set; }
            public int Year { get; set; }

            public override string VehicleKind()
            {
                return "Car";
            }

            public override int VehicleTiresNumber()
            {
                return 4;
            }
        }

        public class CarsDataModified
    {
        private static string[] sellers = new[] { "AlanS", "AlanS", "AlanS", "EdwardE", "JennyC", "JennyC", "JennyC", "JohnD", "JohnD", "JohnD", "LidiaP", "LidiaP", "LidiaP", "MaryJ", "MaryJ", "MaryJ", "PeterB", "PeterB", "PeterB", "PeterB" };
        private static string[] regions = new[] { "US", "Mexico", "Canada", "US", "Portugal", "Luxembourg", "Canada", "Brazil", "Russia", "Argentina", "Russia", "US", "Greece", "Bulgaria", "Australia", "China", "Hungary", "Poland", "Germany", "UK" };
        private static string[] products = new[] { "Product1", "Product2", "Product3", "Product1", "Product5", "Product6", "Product7", "Product8", "Product9", "Product15", "Product4", "Product7", "Product28", "Product78", "Product45", "Product21", "Product8", "Product28", "Product28", "Product28" };
        private static string[] brands = new[] { "Vw", "Vw", "Vw", "Mercedes", "Hyundai", "Renault", "Hyundai", "Vw", "Vw", "Opel", "Ford", "Ferrari", "Ferrari", "Opel", "Opel", "Opel", "Renault", "Renault", "Renault", "Renault" };
        private static string[] models = new[] { "Polo", "Bora", "Bora", "C200", "Sonata", "Laguna", "Elantra", "Polo", "Polo", "Vectra", "Fiesta", "Enzo", "Enzo", "Vectra", "Vectra", "Corsa", "Laguna", "Laguna", "Laguna", "Laguna" };

        private static int[] units = new[] { 50, 20, 30, 40, 20, 35, 25, 40, 15, 25, 40, 50, 40, 25, 70, 35, 80, 45, 15, 10 };
        private static int?[] year = new[] { 2002, 2005, (int?)null, (int?)null, (int?)null, (int?)null, (int?)null, (int?)null, 2008, 2011, 2010, (int?)null, 2004, 2007, 2009, 2004, (int?)null, 2001, 2008, (int?)null };

        private static Int64[] taxes = new[] { 23000000000, 350000000000, 120000000000, 17900000000, 400000000000, 70460000000, 784000000000, 410000000000, 10000000000, 4100000000, 875900000, 7465000000, 2309800000, 10000000000, 4000500000, 17900000000, 450000000000, 17900000000, 4000000000, 5500000000 };
        private static Int64?[] taxesNull = new[] { 23000000000, (Int64?)null, 120000000000, (Int64?)null, 400000000000, (Int64?)null, 784000000000, (Int64?)null, 10000000000, (Int64?)null, (Int64?)null, 7465000000, (Int64?)null, 10000000000, (Int64?)null, 17900000000, (Int64?)null, 17900000000, (Int64?)null, 5500000000 };

        private static decimal[] specOfferPrice = new[] { 5000.25m, 4500.75m, 4300.2555m, 12000.75m, 70.8055m, 55.32555m, 700.5255m, 145.55m, 5500.5m, 7000.5m, 480000.5m, 4000m, 45.250m, 4500.5m, 4595.5m, 780.5m, 875.55m, 965.5m, 210.15m, 80.255m };
        private static decimal?[] tyresCost = new[] { 230.5m, 450.35m, (decimal?)null, (decimal?)null, 235.5m, 600m, 80.5m, (decimal?)null, (decimal?)null, 450m, 650m, (decimal?)null, (decimal?)null, (decimal?)null, 350m, (decimal?)null, (decimal?)null, 230m, (decimal?)null, 650m };
        private static decimal?[] nulls = new[] { (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null, (decimal?)null };

        private static float[] bonus = new[] { 580.75f, 560.5f, 785f, 455.0f, 7850.2655f, 785.5f, 325.455f, 780.5f, 780.5f, 745.5f, 75.5f, 630.5f, 45.235f, 155.5f, 80.95f, 585.5f, 465.25f, 790.955f, 750.95f, 455.5f };
        private static float?[] memberCostReduct = new[] { (float?)null, 205.5f, 300.55f, 40.5f, 85.60f, 850.65f, 860.5f, 405f, 560.55f, (float?)null, (float?)null, (float?)null, (float?)null, 350.5f, 230.5f, (float?)null, (float?)null, (float?)null, 405f, (float?)null };

        private static double[] costs = new[] { 1500.5, 4800.5, 455.25, 1555.5, 9600.0, 845.1005, 450.365, 905.25, 535.25, 740.5, 455.5, 45, 785.5, 125.35, 595.5, 485.5, 565.5, 4555.5, 480.15, 90.5 };
        private static double?[] interest = new[] { 265.5, (double?)null, (double?)null, (double?)null, 450.5, 805.5, (double?)null, 80, 75.5, 4250, (double?)null, (double?)null, 720.55, 505.15, (double?)null, (double?)null, (double?)null, 505.15, (double?)null, (double?)null };

        private static DateTime[] dates = { new DateTime(2011, 12, 03),
                                            new DateTime(2010, 03, 16),
                                            new DateTime(2008, 09, 23),
                                            new DateTime(2011, 12, 03),
                                            new DateTime(2009, 04, 05),
                                            new DateTime(2003, 11, 13),
                                            new DateTime(2008, 09, 06),
                                            new DateTime(2007, 10, 07),
                                            new DateTime(2006, 04, 05),
                                            new DateTime(2002, 12, 08),
                                            new DateTime(2004, 09, 09),
                                            new DateTime(2011, 12, 12),
                                            new DateTime(2012, 11, 24),
                                            new DateTime(2006, 04, 30),
                                            new DateTime(2001, 03, 29),
                                            new DateTime(2006, 07, 17),
                                            new DateTime(2004, 09, 16),
                                            new DateTime(2005, 08, 08),
                                            new DateTime(2002, 02, 04),
                                            new DateTime(2007, 03, 16),
                                            new DateTime(2001, 05, 17),
                                            new DateTime(2008, 02, 16),
                                          };

        [DisplayAttribute(Name = "Sales Region")]
        public string Region
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "Sales Person", Description = "The name of the sales person.")]
        public string Seller
        {
            get;
            set;
        }

        public string Product
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:####} pcs.")]
        public int Units
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:####}")]
        public int? Year
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Cost")]
        public double Cost
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Interest")]
        public double? Interest
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Tax")]
        public Int64 Tax
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Tax Null")]
        public Int64? TaxNull
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Special Offer Price")]
        public decimal SpecialOfferPrice
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Tyres Cost")]
        public decimal? TyresCost
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "All Null decimal?s")]
        public decimal? AllNulls
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Bonus")]
        public float Bonus
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C3}")]
        [DisplayAttribute(Name = "Member Cost Reduction")]
        public float? MemberCostReduct
        {
            get;
            set;
        }

        public DateTime Date
        {
            get;
            set;
        }

        [Display(Name = "Vehicle Model")]
        public Car Vehicle
        {
            get;
            set;
        }

        public static IEnumerable<CarsDataModified> GenerateDataCustom20()
        {
            ObservableCollection<CarsDataModified> pData = new ObservableCollection<CarsDataModified>();

            for (int i = 0; i < 20; i++)
            {
                CarsDataModified pd = new CarsDataModified();

                pd.Region = regions[i];
                pd.Seller = sellers[i];
                pd.Product = products[i];

                pd.Units = units[i];
                pd.Year = year[i];

                pd.Cost = costs[i];
                pd.Interest = interest[i];

                pd.Tax = taxes[i];
                pd.TaxNull = taxesNull[i];

                pd.SpecialOfferPrice = specOfferPrice[i];
                pd.TyresCost = tyresCost[i];
                pd.AllNulls = nulls[i];

                pd.Bonus = bonus[i];
                pd.MemberCostReduct = memberCostReduct[i];

                pd.Date = dates[i];

                pd.Vehicle = new Car { Brand = brands[i], Model = models[i] };

                pData.Add(pd);
            }

            return pData;
        }
        }

      

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.CreateFlatData();

            (LayoutRoot.Resources["connSettings"] as FlatDataConnectionSettings).ItemsSource = this.FlatData;

            comboBox.ItemsSource = new string[] { "format 1 {0}", "format 2 {0}", "format 3 {0}", };
        }

    

   

        private void pivotGrid_CellControlAttached(object sender, PivotCellControlAttachedEventArgs e)
        {
            if (e.Cell.Data != null && e.Cell.Data.GetType() == typeof(Cell) && (e.Cell.Data as Cell).Value != null)
            {
                if ((e.Cell.Column as PivotDataColumn).Tuple.ToString().Contains("Cost"))
                {
                    e.Cell.Style = LayoutRoot.Resources["CellStyle"] as Style;
                }
            }
            e.Cell.ToString();
        }
    }


    public class MultiFormatValueConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            double temp;
            try
            {
                if (double.TryParse((values[0] as Cell).Value.ToString(), out temp))
                {
                    if (values[1] != null)
                    {
                        return String.Format(values[1] as string, temp);
                    }
                    else
                        return (values[0] as Cell).Value.ToString();
                }
                return Binding.DoNothing;
            }
            catch (NullReferenceException)
            {
                return Binding.DoNothing;
            }
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            return new object[] { };
        }
    }


}
